local MEKA = unpack(select(2, ...))  -->Engine
local E, C, F, L = unpack(Quafe)  -->Engine, Config, Function, Locale

--- ------------------------------------------------------------
--> API Localization
--- ------------------------------------------------------------

local _G = getfenv(0)
local format = string.format
local find = string.find

local min = math.min
local max = math.max
local floor = math.floor
local sqrt = math.sqrt
local sin = math.sin
local cos = math.cos
local rad = math.rad
local acos = math.acos
local atan = math.atan
local rad = math.rad
local modf = math.modf

local insert = table.insert
local remove = table.remove
local wipe = table.wipe

--- ------------------------------------------------------------
--> Create Player CastBar
--- ------------------------------------------------------------

local function PlayerCastBar_ColorRing(frame, color)
	frame.LR.Ring: SetVertexColor(F.Color(color))
	frame.RR.Ring: SetVertexColor(F.Color(color))
end

local function PlayerCastBar_UpdateRing(frame, d)
	if not d then d = 1 end
	d = min(max(d, 0), 1)
	if frame.LR then
		frame.LR.Ring:SetRotation(math.rad(frame.LR.Base-frame.LR.Range*d))
	end
	if frame.RR then
		frame.RR.Ring:SetRotation(math.rad(frame.RR.Base+frame.RR.Range*d))
	end
end

local function Ring_Artwork(frame, size, texture, bgangle)
	local SC = CreateFrame("Frame", nil, frame)
	SC: SetSize(size, size)
	frame: SetScrollChild(SC)
	
	local Ring = SC:CreateTexture(nil, "ARTWORK")
	Ring: SetTexture(MEKA.Path(texture))
	Ring: SetSize(size, size)
    Ring: SetPoint("CENTER")
    Ring: SetVertexColor(F.Color(C.Color.Main1))
	Ring: SetAlpha(1)
	--Ring: SetBlendMode("BLEND")
	Ring: SetRotation(math.rad(frame.Base))

	local RingBg = SC:CreateTexture(nil, "BACKGROUND")
	RingBg: SetTexture(MEKA.Path(texture.."_Sd"))
	RingBg: SetSize(size, size)
    RingBg: SetPoint("CENTER")
    RingBg: SetVertexColor(F.Color(C.Color.Main0))
	RingBg: SetAlpha(0.25)
	RingBg: SetRotation(math.rad(frame.Base+bgangle))

	frame.Ring = Ring
	frame.RingBg = RingBg
end

local function Create_Ring(frame, size, texture)
	frame.LR = CreateFrame("ScrollFrame", nil, frame)
	frame.LR: SetSize((size)/2, size)
	frame.LR: SetPoint("RIGHT", frame, "CENTER", 0,0)
	frame.LR.Base = 0
	frame.LR.Range = 30
	Ring_Artwork(frame.LR, size, texture, -30)
	
	frame.RR = CreateFrame("ScrollFrame", nil, frame)
	frame.RR: SetSize((size)/2, size)
	frame.RR: SetPoint("LEFT", frame, "CENTER", 0,0)
	frame.RR: SetHorizontalScroll((size)/2)
	frame.RR.Base = -180
	frame.RR.Range = 30
	Ring_Artwork(frame.RR, size, texture, 30)
end

local function PlayerCastBar_Artwork(frame)
	local LeftBD = frame:CreateTexture(nil, "ARTWORK")
	LeftBD: SetTexture(MEKA.Path("RingBar\\Castbar1_Bd1"))
	LeftBD: SetVertexColor(F.Color(C.Color.Warn1))
	LeftBD: SetAlpha(0.9)
	LeftBD: SetSize(32,32)
	LeftBD: SetPoint("CENTER", frame, "CENTER", 175*cos(rad(-122)), 175*sin(rad(-122)))
	F.RotateTexture(LeftBD, -32)

	local RightBD = frame:CreateTexture(nil, "ARTWORK")
	RightBD: SetTexture(MEKA.Path("RingBar\\Castbar1_Bd1"))
	RightBD: SetVertexColor(F.Color(C.Color.Warn1))
	RightBD: SetAlpha(0.9)
	RightBD: SetSize(32,32)
	RightBD: SetPoint("CENTER", frame, "CENTER", 175*cos(rad(-58)), 175*sin(rad(-58)))
	F.RotateTexture(RightBD, 32)

	local Num = {}
	for i = 1,7 do
		Num[i] = frame:CreateTexture(nil, "ARTWORK")
		Num[i]: SetTexture(MEKA.Path("N12\\N0"))
		Num[i]: SetVertexColor(F.Color(C.Color.Warn1))
		Num[i]: SetAlpha(1)
		Num[i]: SetSize(32,32)
		Num[i]: SetPoint("CENTER", frame, "CENTER", 190*cos(rad(-90-12+3*i)), 190*sin(rad(-90-12+3*i)))
		F.RotateTexture(Num[i], -12+3*i)
	end

	frame.Num = Num
end

local function PlayerCastBar_ColorNum(frame, color)
	for i = 1,7 do
		frame.Num[i]: SetVertexColor(F.Color(color))
	end
end

local function Conversion_Time(time)
	local v1,v2,v3
	if time then
		if time < 0 then time = 0 end
		if time > 99 then time = 99 end
	else
		time = 0 
	end
	if time < 10 then
		time = time * 10
		v2 = "p"
	else
		v2 = "b"
	end
	v1 = floor(time/10)
	v3 = floor(time) - v1*10
	return v1,v2,v3
end

local function PlayerCastBar_UnpdateNum(frame, blank)
	if blank then
		for i = 1,7 do
			frame.Num[i]: SetTexture(MEKA.Path("N12\\Nb"))
		end
	else
		frame.Num[4]: SetTexture(MEKA.Path("N12\\Nslash"))
		local v1,v2,v3,v4,v5,v6
		if frame.Channeling then
			v1,v2,v3 = Conversion_Time(frame.Value)
		else
			v1,v2,v3 = Conversion_Time(frame.MaxValue-frame.Value)
		end

		v4,v5,v6 = Conversion_Time(frame.MaxValue)
		if v2 == "p" then
			frame.Num[1]: SetTexture(MEKA.Path("N12\\N"..v1))
			frame.Num[2]: SetTexture(MEKA.Path("N12\\N"..v2))
			frame.Num[3]: SetTexture(MEKA.Path("N12\\N"..v3))
		elseif v2 == "b" then
			frame.Num[1]: SetTexture(MEKA.Path("N12\\N"..v2))
			frame.Num[2]: SetTexture(MEKA.Path("N12\\N"..v1))
			frame.Num[3]: SetTexture(MEKA.Path("N12\\N"..v3))
		end
		if v5 == "p" then
			frame.Num[5]: SetTexture(MEKA.Path("N12\\N"..v4))
			frame.Num[6]: SetTexture(MEKA.Path("N12\\N"..v5))
			frame.Num[7]: SetTexture(MEKA.Path("N12\\N"..v6))
		elseif v5 == "b" then
			frame.Num[5]: SetTexture(MEKA.Path("N12\\N"..v4))
			frame.Num[6]: SetTexture(MEKA.Path("N12\\N"..v6))
			frame.Num[7]: SetTexture(MEKA.Path("N12\\N"..v5))
		end
	end
end

local function PlayerCastBar_ApplyUpdate(frame, value)
	if value then
		PlayerCastBar_UpdateRing(frame, value)
	end
	PlayerCastBar_UpdateRing(frame, frame.Value/frame.MaxValue)
	PlayerCastBar_UnpdateNum(frame, value)
end

local function PlayerCastBar_ApplyAlpha(frame, alpha)
	frame: SetAlpha(alpha)
end

local CAST_COLOR = {
	Cast = C.Color.Blue,
	Shield = C.Color.Yellow,
	Stop = C.Color.Green,
	Fail = C.Color.Red,
}

local function PlayerCastBar_ApplyColor(frame, state, notInterruptible)
	if state == "Start" then
		if notInterruptible then
			PlayerCastBar_ColorRing(frame, CAST_COLOR.Shield)
			PlayerCastBar_ColorNum(frame, CAST_COLOR.Shield)
		else
			PlayerCastBar_ColorRing(frame, CAST_COLOR.Cast)
			PlayerCastBar_ColorNum(frame, CAST_COLOR.Cast)
		end
	elseif state == "Finished" then
		PlayerCastBar_ColorRing(frame, CAST_COLOR.Stop)
		PlayerCastBar_ColorNum(frame, CAST_COLOR.Stop)
	elseif state == "Failed" then
		PlayerCastBar_ColorRing(frame, CAST_COLOR.Fail)
		PlayerCastBar_ColorNum(frame, CAST_COLOR.Fail)
	end
end

local function PlayerCastBar_Create(frame)
	local PlayerCastBar = CreateFrame("frame", "MEKA_PlayerCastBar", frame)
	PlayerCastBar: SetSize(16, 16)
	PlayerCastBar: SetPoint("CENTER", UIParent, "CENTER", 0,0)
	PlayerCastBar.RingSize = 512

	Create_Ring(PlayerCastBar, PlayerCastBar.RingSize, "RingBar\\Castbar1")
	PlayerCastBar_Artwork(PlayerCastBar)

	PlayerCastBar.Unit = "player"
	PlayerCastBar.EnableCastbar = true
	PlayerCastBar.ShowCastbar = true
	PlayerCastBar.ShowTradeSkills = true
	PlayerCastBar.ApplyUpdate = PlayerCastBar_ApplyUpdate
	PlayerCastBar.ApplyAlpha = PlayerCastBar_ApplyAlpha
	PlayerCastBar.ApplyColor = PlayerCastBar_ApplyColor
	F.CastBar_Create(PlayerCastBar)

	frame.PlayerCastBar = PlayerCastBar
end

--- ------------------------------------------------------------
--> Create Pet CastBar
--- ------------------------------------------------------------

local function PetCastBar_Artwork(frame)
	local LeftBD = frame:CreateTexture(nil, "ARTWORK")
	LeftBD: SetTexture(MEKA.Path("RingBar\\Castbar1_Bd1"))
	LeftBD: SetVertexColor(F.Color(C.Color.Warn1))
	LeftBD: SetAlpha(0.9)
	LeftBD: SetSize(32,32)
	LeftBD: SetPoint("CENTER", frame, "CENTER", 150*cos(rad(-122)), 150*sin(rad(-122)))
	F.RotateTexture(LeftBD, -32)

	local RightBD = frame:CreateTexture(nil, "ARTWORK")
	RightBD: SetTexture(MEKA.Path("RingBar\\Castbar1_Bd1"))
	RightBD: SetVertexColor(F.Color(C.Color.Warn1))
	RightBD: SetAlpha(0.9)
	RightBD: SetSize(32,32)
	RightBD: SetPoint("CENTER", frame, "CENTER", 150*cos(rad(-58)), 150*sin(rad(-58)))
	F.RotateTexture(RightBD, 32)

	local Num = {}
	for i = 1,7 do
		Num[i] = frame:CreateTexture(nil, "ARTWORK")
		Num[i]: SetTexture(MEKA.Path("N12\\N0"))
		Num[i]: SetVertexColor(F.Color(C.Color.Warn1))
		Num[i]: SetAlpha(1)
		Num[i]: SetSize(32,32)
		Num[i]: SetPoint("CENTER", frame, "CENTER", 135*cos(rad(-90-16+4*i)), 135*sin(rad(-90-16+4*i)))
		F.RotateTexture(Num[i], -16+4*i)
	end

	frame.Num = Num
end

local function PetCastBar_OnEvent(frame, event, ...)
	local arg1 = ...;
	if ( event == "UNIT_PET" ) then
		if ( arg1 == "player" ) then
			frame.ShowCastbar = UnitIsPossessed("pet");

			if ( not frame.ShowCastbar ) then
				frame: Hide();
			elseif ( frame.Casting or frame.Channeling ) then
				frame: Show();
			end
		end
		return
	end
end

local function PetCastBar_Create(frame)
	local PetCastBar = CreateFrame("frame", "MEKA_PetCastBar", frame)
	PetCastBar: SetSize(16, 16)
	PetCastBar: SetPoint("CENTER", UIParent, "CENTER", 0,0)
	PetCastBar.RingSize = 512

	Create_Ring(PetCastBar, PetCastBar.RingSize, "RingBar\\Castbar2")
	PetCastBar_Artwork(PetCastBar)

	PetCastBar: RegisterEvent("UNIT_PET")

	PetCastBar.Unit = "pet"
	PetCastBar.EnableCastbar = true
	PetCastBar.ShowCastbar = UnitIsPossessed("pet")
	PetCastBar.ShowTradeSkills = false
	PetCastBar.ApplyUpdate = PlayerCastBar_ApplyUpdate
	PetCastBar.ApplyAlpha = PlayerCastBar_ApplyAlpha
	PetCastBar.ApplyColor = PlayerCastBar_ApplyColor
	PetCastBar.ApplyEvent = PetCastBar_OnEvent
	F.CastBar_Create(PetCastBar)

	frame.PetCastBar = PetCastBar
end

--- ------------------------------------------------------------
--> MEKA CastBar
--- ------------------------------------------------------------

local MEKA_CastBar = CreateFrame("frame", nil, E)
MEKA_CastBar: SetSize(16, 16)
MEKA_CastBar: SetPoint("CENTER", UIParent, "CENTER", 0,0)
MEKA_CastBar.Init = false

local function MEKA_CastBar_Load()
	if Quafe_DB.Profile[Quafe_DBP.Profile]["MEKA_CastBar"].Enable then
		PlayerCastBar_Create(MEKA_CastBar)
		PetCastBar_Create(MEKA_CastBar)
		F.HideFrame(CastingBarFrame, true, true)
		F.HideFrame(PetCastingBarFrame, true, true)
		MEKA_CastBar.Init = true
	end
end

local function MEKA_CastBar_Toggle(arg1, arg2)
	if arg1 == "ON" then
		if not arg2 then
			MEKA_CastBar: Show()
			if not MEKA_CastBar.Init then
				MEKA_CastBar_Load()
			end
		elseif arg2 == "Player" then
			MEKA_CastBar.PlayerCastBar.EnableCastbar = true
			MEKA_CastBar.PetCastBar.EnableCastbar = true
		end
	elseif arg1 == "OFF" then
		if not arg2 then
			MEKA_CastBar: Hide()
		elseif arg2 == "Player" then
			MEKA_CastBar.PlayerCastBar.EnableCastbar = false
			MEKA_CastBar.PetCastBar.EnableCastbar = false
		end
	end
end

local MEKA_CastBar_Config = {
	Database = {
		["MEKA_CastBar"] = {
			Enable = true,
			PlayerCastBar = true,
		},
	},

	Config = {
		Name = "MEKA "..L['施法条'],
		Type = "Switch",
		Click = function(self, button)
			if Quafe_DB.Profile[Quafe_DBP.Profile]["MEKA_CastBar"].Enable then
				Quafe_DB.Profile[Quafe_DBP.Profile]["MEKA_CastBar"].Enable = false
				self.Text:SetText(L["OFF"])
				MEKA_CastBar_Toggle("OFF")
			else
				Quafe_DB.Profile[Quafe_DBP.Profile]["MEKA_CastBar"].Enable = true
				self.Text:SetText(L["ON"])
				MEKA_CastBar_Toggle("ON")
			end
		end,
		Show = function(self)
			if Quafe_DB.Profile[Quafe_DBP.Profile]["MEKA_CastBar"].Enable then
				self.Text:SetText(L["ON"])
			else
				self.Text:SetText(L["OFF"])
			end
		end,
		Sub = {
			[1] = {
				Name = L['PLAYER'],
				Type = "Switch",
				Click = function(self, button)
					if Quafe_DB.Profile[Quafe_DBP.Profile]["MEKA_CastBar"].PlayerCastBar then
						Quafe_DB.Profile[Quafe_DBP.Profile]["MEKA_CastBar"].PlayerCastBar = false
						self.Text:SetText(L["OFF"])
						MEKA_CastBar_Toggle("OFF", "Player")
					else
						Quafe_DB.Profile[Quafe_DBP.Profile]["MEKA_CastBar"].PlayerCastBar = true
						self.Text:SetText(L["ON"])
						MEKA_CastBar_Toggle("ON", "Player")
					end
				end,
				Show = function(self)
					if Quafe_DB.Profile[Quafe_DBP.Profile]["MEKA_CastBar"].PlayerCastBar then
						self.Text:SetText(L["ON"])
					else
						self.Text:SetText(L["OFF"])
					end
				end,
			},
		},
	},
}

MEKA_CastBar.Load = MEKA_CastBar_Load
MEKA_CastBar.Config = MEKA_CastBar_Config
tinsert(E.Module, MEKA_CastBar)